# TODO
# - use policykit to gain root
# - use %caps when rpm supports it: %attr(750,root,wireshark) %caps(cap_net_raw,cap_net_admin=eip) %{_sbindir}/dumpcap
#
# Conditional build:
%bcond_without	kerberos5	# Kerberos V support
%bcond_without	snmp		# SNMP support
%bcond_without	gui		# without QT GUI

%define		branch_ver	3.4
Summary:	Network traffic and protocol analyzer
Summary(es.UTF-8):	Analizador de tráfico de red
Summary(pl.UTF-8):	Analizator ruchu i protokołów sieciowych
Summary(pt_BR.UTF-8):	Analisador de tráfego de rede
Summary(ru.UTF-8):	Анализатор сетевого траффика
Summary(uk.UTF-8):	Аналізатор мережевого трафіку
Name:		wireshark
Version:	3.4.8
Release:	1
License:	GPL v2+
Group:		Networking/Utilities
Source0:	https://www.wireshark.org/download/src/%{name}-%{version}.tar.xz
# Source0-md5:	13aea3ee0edbc8f875971eccf2d11b20
URL:		https://www.wireshark.org/
BuildRequires:	bcg729-devel
BuildRequires:	bison
BuildRequires:	cmake >= 3.5
BuildRequires:	c-ares-devel >= 1.5.0
BuildRequires:	doxygen
BuildRequires:	flex
BuildRequires:	gcc >= 5:3.2
BuildRequires:	gettext-tools
BuildRequires:	glib2-devel >= 1:2.32
BuildRequires:	gnutls-devel >= 3.2.0
%{?with_kerberos5:BuildRequires:	heimdal-devel}
BuildRequires:	libbrotli-devel
BuildRequires:	libcap-devel
BuildRequires:	libgcrypt-devel >= 1.4.2
BuildRequires:	libmaxminddb-devel
BuildRequires:	libnl-devel >= 3.2
BuildRequires:	libpcap-devel >= 2:1.0.0-4
BuildRequires:	libssh-devel >= 0.6.0
BuildRequires:	libsmi-devel
BuildRequires:	libstdc++-devel >= 6:4.7
BuildRequires:	libtool >= 2:2.2.2
BuildRequires:	libxml2-devel >= 2.0
BuildRequires:	libxslt-progs
BuildRequires:	lua52-devel
BuildRequires:	lz4-devel
BuildRequires:	minizip-devel
%{?with_snmp:BuildRequires:	net-snmp-devel}
BuildRequires:	nghttp2-devel
BuildRequires:	perl-tools-pod
BuildRequires:	pkgconfig >= 1:0.7
BuildRequires:	python3 >= 1:3.4
BuildRequires:	rpmbuild(macros) >= 1.527
BuildRequires:	ruby-asciidoctor >= 1.5
%{?with_gui:BuildRequires:	sbc-devel >= 1.0}
BuildRequires:	sed >= 4.0
%{?with_gui:BuildRequires:	speexdsp-devel}
BuildRequires:	snappy-devel
BuildRequires:	spandsp-devel
BuildRequires:	systemd-devel
BuildRequires:	tar >= 1:1.22
BuildRequires:	w3m
BuildRequires:	xz
BuildRequires:	zstd-devel >= 1.0.0
BuildRequires:	zlib-devel
%if %{with gui}
BuildRequires:	Qt5Core-devel >= 5.2
BuildRequires:	Qt5Multimedia-devel >= 5.2
BuildRequires:	Qt5PrintSupport-devel >= 5.2
BuildRequires:	Qt5Svg-devel >= 5.2
BuildRequires:	Qt5Widgets-devel >= 5.2
BuildRequires:	libstdc++-devel >= 6:5
BuildRequires:	qt5-build >= 5.2
BuildRequires:	qt5-linguist >= 5.2
%endif
Requires(post,postun):	gtk-update-icon-cache
Requires(post,postun):	shared-mime-info
Requires:	gdk-pixbuf2 >= 2.26
Requires:	hicolor-icon-theme
Suggests:	xdg-utils
Provides:	ethereal
Provides:	ethereal-gnome
Obsoletes:	ethereal
Obsoletes:	ethereal-gnome
Obsoletes:	wireshark-gui-common
Obsoletes:	wireshark-qt
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Wireshark is the name for powerful graphical network sniffer, traffic
and protocol analyzer based on QT and libpcap libraries. It lets you
capture and interactively browse the contents of network frames with
vast knowledge of more than 100 network protocols. Wireshark has
severeal useful features, including a rich display filter language,
the ability to view the ASCII contents of a TCP connection and plug-in
capabilities.

%description -l es.UTF-8
Analizador de tráfico de red.

%description -l pl.UTF-8
Wireshark jest potężnym, graficznym snifferem, analizatorem ruchu oraz
protokołów sieciowych opartym na bibliotekach QT oraz libpcap.
Umożliwia on przechwytywanie oraz interaktywną analizę zawartości
ramek oraz ponad stu protokołów sieciowych. Wireshark posiada wiele
użytecznych cech, takich jak rozbudowany język filtrów wyświetlania,
możliwość oglądania przebiegu sesji TCP oraz możliwość dołączania
wtyczek (plug-ins).

%description -l pt_BR.UTF-8
O Wireshark é um analisador de protocolo de rede baseado no QT.

%description -l ru.UTF-8
Wireshark - это анализатор сетевого траффика для Unix-подобных ОС. Он
базируется на QT и libpcap.

%description -l uk.UTF-8
Wireshark - це аналізатор мережевого трафіку для Unix-подібних ОС. Він
базується на QT та libpcap.

%package common
Summary:	Network traffic and protocol analyzer - common files
Summary(pl.UTF-8):	Analizator ruchu i protokołów sieciowych - wspólne pliki
Group:		Networking
Requires(post,postun):	/sbin/setcap
Requires:	%{name}-libs = %{version}-%{release}
Requires:	gnutls >= 3.1.10
Requires:	libpcap >= 0.4
Requires:	libssh >= 0.6.0
Provides:	ethereal-common
Provides:	group(wireshark)
Provides:	wireshark-tools
Obsoletes:	ethereal-common
Obsoletes:	wireshark-tools

%description common
Wireshark is the name for powerful graphical network sniffer, traffic
and protocol analyzer based on QT and libpcap libraries. It lets you
capture and interactively browse the contents of network frames with
vast knowledge of more than 100 network protocols. Wireshark has
severeal useful features, including a rich display filter language,
the ability to view the ASCII contents of a TCP connection and plug-in
capabilities.

This package provides the shared library, plugins, data and a set of
tools for manipulating capture files. It contains:
- capinfos - prints informatio about binary capture files,
- captype - prints the file types of capture files,
- dftest - shows display filter byte-code,
- dumpcap - dumps network traffic to a file,
- editcap - edit and/or translate the format of capture files,
- mergecap - merges two capture files into one,
- randpkt - generates libpcap trace file full of random packets,
- rawshark - dumps and analyzes raw libpcap data,
- text2cap - generate a capture file from an ASCII hexdump of packets.

%description common -l es.UTF-8
Analizador de tráfico de red.

%description common -l pl.UTF-8
Wireshark jest potężnym, graficznym snifferem, analizatorem ruchu oraz
protokołów sieciowych opartym na bibliotekach QT oraz libpcap.
Umożliwia on przechwytywanie oraz interaktywną analizę zawartości
ramek oraz ponad stu protokołów sieciowych. Wireshark posiada wiele
użytecznych cech, takich jak rozbudowany język filtrów wyświetlania,
możliwość oglądania przebiegu sesji TCP oraz możliwość dołączania
wtyczek (plug-ins).

Ten pakiet ten zawiera bibliotekę współdzieloną, wtyczki, dane oraz
zestaw narzędzi do obróbki plików z przechwyconymi pakietami,
obejmujący:
- capinfos - do wyświetlania informacji o binarnych plikach zrzutu,
- captype - do wyświetlania rodzaju plików zrzutu,
- dftest - do pokazywania bajtkodu filtrów wyświetlania,
- dumpcap - do zrzucania ruchu sieciowego do pliku,
- editcap - do edycji plików i tłumaczenia ich na inne formaty,
- mergecap - do łączenia dwóch plików w jeden,
- randpkt - do generowania plikow cap z losowymi danymi,
- rawshark - do obróbki plików cap,
- text2cap - do generowania pliku cap z szesnastkowego zrzutu ASCII
  pakietów.

%description common -l pt_BR.UTF-8
O Wireshark é um analisador de protocolo de rede baseado no QT.

%description common -l ru.UTF-8
Wireshark - это анализатор сетевого траффика для Unix-подобных ОС. Он
базируется на QT и libpcap.

%description common -l uk.UTF-8
Wireshark - це аналізатор мережевого трафіку для Unix-подібних ОС. Він
базується на QT та libpcap.

%package -n twireshark
Summary:	Text-mode network traffic and protocol analyzer
Summary(pl.UTF-8):	Tekstowy analizator ruchu i protokołów sieciowych
Summary(pt_BR.UTF-8):	Analisador modo texto de tráfego de rede (sniffer)
Group:		Networking
Requires:	%{name}-common = %{version}-%{release}
Requires:	libpcap >= 0.4
Provides:	tethereal
Obsoletes:	tethereal

%description -n twireshark
Twireshark is a network protocol analyzer. It lets you capture packet
data from a live network, or read packets from a previously saved
capture file, either printing a decoded form of those packets to the
standard output or writing the packets to a file. Twireshark's native
capture file format is libpcap format, which is also the format used
by tcpdump and various other tools.

%description -n twireshark -l pl.UTF-8
Twireshark jest analizatorem protokołów sieciowych. Pozwala na
przechwytywanie pakietów z sieci lub wczytywanie danych z pliku.
Zdekodowany wynik (a twireshark zna ponad 100 rozmaitych protokołów
sieciowych!) jest wyświetlony na ekranie. Natywnym formatem plików
tetherala jest format libpcap, tak więc jest on kompatybilny z
tcpdumpem i innymi podobnymi narzędziami.

%description -n twireshark -l pt_BR.UTF-8
Esta é uma versão para modo texto do analisador de tráfego de rede
Wireshark.

%package libs
Summary:	Wireshark packet capture and dissection libraries
Summary(pl.UTF-8):	Biblioteki Wiresharka do przechwytywania i sekcji pakietów
Group:		Libraries
Requires:	glib2 >= 1:2.32
Requires:	libgcrypt >= 1.4.2
Requires:	libnl >= 3.2
Obsoletes:	libwiretap < 2.4.0

%description libs
Wireshark packet capture and dissection libraries.

%description libs -l pl.UTF-8
Biblioteki Wiresharka do przechwytywania i sekcji pakietów.

%package devel
Summary:	Header files for Wireshark libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek Wiresharka
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	glib2-devel >= 1:2.32
Requires:	libgcrypt-devel >= 1.4.2
Requires:	libnl-devel >= 3.2
Obsoletes:	libwiretap-devel < 2.4.0

%description devel
Header files for Wireshark libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek Wiresharka.

%prep
%setup -q

%build
install -d build
cd build
%cmake .. \
	-DBUILD_androiddump=ON \
	-DBUILD_corbaidl2wrs=ON \
	-DBUILD_dcerpcidl2wrs=ON \
	-DBUILD_mmdbresolve=ON \
	-DBUILD_randpktdump=ON \
	-DBUILD_tfshark=OFF \
	-DBUILD_wireshark=ON \
	-DCMAKE_INSTALL_DATADIR:PATH=share/wireshark \
	-DCMAKE_INSTALL_LIBDIR:PATH=%{_lib} \
	-DDISABLE_WERROR=ON \
	-DENABLE_LUA=ON \
	-DENABLE_NETLINK=ON \
	-DENABLE_PLUGINS=ON \
	-DENABLE_PORTAUDIO=ON \
	-DENABLE_QT5=ON \
	-DENABLE_SMI=ON

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

# used by installed headers, but not installed by cmake
cp -p build/config.h $RPM_BUILD_ROOT%{_includedir}/wireshark

%{__rm} $RPM_BUILD_ROOT%{_docdir}/*.html

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%update_icon_cache hicolor
%update_mime_database

%postun
%update_icon_cache hicolor
%update_mime_database

%pre	common
%groupadd -P %{name}-common -g 104 wireshark

%post	common
/sbin/setcap 'CAP_NET_RAW+eip CAP_NET_ADMIN+eip' %{_bindir}/dumpcap
exit 0

%postun	common
if [ "$1" = "0" ]; then
	%groupremove wireshark
fi

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%if %{with gui}
%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/wireshark
%{_desktopdir}/wireshark.desktop
%{_datadir}/%{name}
%{_datadir}/appdata/wireshark.appdata.xml
%{_datadir}/mime/packages/wireshark.xml
%{_iconsdir}/hicolor/16x16/apps/%{name}.png
%{_iconsdir}/hicolor/16x16/mimetypes/application-%{name}-doc.png
%{_iconsdir}/hicolor/24x24/apps/%{name}.png
%{_iconsdir}/hicolor/24x24/mimetypes/application-%{name}-doc.png
%{_iconsdir}/hicolor/32x32/apps/%{name}.png
%{_iconsdir}/hicolor/32x32/mimetypes/application-%{name}-doc.png
%{_iconsdir}/hicolor/48x48/apps/%{name}.png
%{_iconsdir}/hicolor/48x48/mimetypes/application-%{name}-doc.png
%{_iconsdir}/hicolor/64x64/apps/%{name}.png
%{_iconsdir}/hicolor/64x64/mimetypes/application-%{name}-doc.png
%{_iconsdir}/hicolor/128x128/apps/%{name}.png
%{_iconsdir}/hicolor/128x128/mimetypes/application-%{name}-doc.png
%{_iconsdir}/hicolor/256x256/apps/%{name}.png
%{_iconsdir}/hicolor/256x256/mimetypes/application-%{name}-doc.png
%{_iconsdir}/hicolor/scalable/apps/%{name}.svg
%{_mandir}/man1/wireshark.1*
%endif

%files common
%defattr(644,root,root,755)
%doc AUTHORS* ChangeLog NEWS README.md README.linux doc/README.*
%dir %{_libdir}/%{name}/extcap
%dir %{_libdir}/%{name}/plugins
%dir %{_libdir}/%{name}/plugins/%{branch_ver}
%dir %{_libdir}/%{name}/plugins/%{branch_ver}/codecs
%dir %{_libdir}/%{name}/plugins/%{branch_ver}/epan
%dir %{_libdir}/%{name}/plugins/%{branch_ver}/wiretap
%attr(755,root,root) %{_libdir}/%{name}/extcap/androiddump
%attr(755,root,root) %{_libdir}/%{name}/extcap/ciscodump
%attr(755,root,root) %{_libdir}/%{name}/extcap/dpauxmon
%attr(755,root,root) %{_libdir}/%{name}/extcap/randpktdump
%attr(755,root,root) %{_libdir}/%{name}/extcap/sshdump
%attr(755,root,root) %{_libdir}/%{name}/extcap/sdjournal
%attr(755,root,root) %{_libdir}/%{name}/extcap/udpdump
%attr(755,root,root) %{_libdir}/%{name}/plugins/%{branch_ver}/codecs/*.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/%{branch_ver}/epan/*.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/%{branch_ver}/wiretap/*.so
%attr(755,root,root) %{_bindir}/capinfos
%attr(755,root,root) %{_bindir}/captype
%attr(750,root,wireshark) %{_bindir}/dumpcap
%attr(755,root,root) %{_bindir}/editcap
%attr(755,root,root) %{_bindir}/idl2wrs
%attr(755,root,root) %{_bindir}/mergecap
%attr(755,root,root) %{_bindir}/mmdbresolve
%attr(755,root,root) %{_bindir}/randpkt
%attr(755,root,root) %{_bindir}/rawshark
%attr(755,root,root) %{_bindir}/reordercap
%attr(755,root,root) %{_bindir}/sharkd
%attr(755,root,root) %{_bindir}/text2pcap
%{_mandir}/man1/androiddump.1*
%{_mandir}/man1/capinfos.1*
%{_mandir}/man1/captype.1*
%{_mandir}/man1/ciscodump.1*
%{_mandir}/man1/dftest.1*
%{_mandir}/man1/dpauxmon.1*
%{_mandir}/man1/dumpcap.1*
%{_mandir}/man1/editcap.1*
%{_mandir}/man1/idl2wrs.1*
%{_mandir}/man1/mergecap.1*
%{_mandir}/man1/mmdbresolve.1*
%{_mandir}/man1/rawshark.1*
%{_mandir}/man1/randpkt.1*
%{_mandir}/man1/randpktdump.1*
%{_mandir}/man1/reordercap.1*
%{_mandir}/man1/sdjournal.1*
%{_mandir}/man1/sshdump.1*
%{_mandir}/man1/text2pcap.1*
%{_mandir}/man1/udpdump.1*
%{_mandir}/man4/extcap.4*
%{_mandir}/man4/wireshark-filter.4*

%files -n twireshark
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/tshark
%{_mandir}/man1/tshark*.1*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libwireshark.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libwireshark.so.14
%attr(755,root,root) %{_libdir}/libwiretap.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libwiretap.so.11
%attr(755,root,root) %{_libdir}/libwsutil.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libwsutil.so.12
%dir %{_libdir}/%{name}

%files devel
%defattr(644,root,root,755)
%doc wiretap/{README,README.airmagnet}
%attr(755,root,root) %{_libdir}/libwireshark.so
%attr(755,root,root) %{_libdir}/libwiretap.so
%attr(755,root,root) %{_libdir}/libwsutil.so
%{_includedir}/wireshark
%{_pkgconfigdir}/wireshark.pc
%{_libdir}/%{name}/cmake
%changelog
* Sun Aug 29 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/wireshark.git;a=log;h=master

* Sun Aug 29 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 8ab5803
- up to 3.4.8

* Fri Jul 02 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 1623694
- up to 3.4.6

* Sun Jun 21 2020 Jakub Bogusz <qboosh@pld-linux.org> 2d1c32b
- dropped cmake patch to fix .pc file (CMAKE_INSTALL_LIBDIR is relative to prefix now); release 2

* Sun Jun 21 2020 Jakub Bogusz <qboosh@pld-linux.org> c0f5284
- updated to 3.2.4 (new sonames)
- fixed data packaging

* Wed Apr 10 2019 Adam Gołębiowski <adamg@pld-linux.org> cab6664
- updated to 3.0.1, solves:
    wnpa-sec-2019-09 NetScaler file parser crash. Bug 15497. CVE-2019-10895.
    wnpa-sec-2019-10 SRVLOC dissector crash. Bug 15546. CVE-2019-10899.
    wnpa-sec-2019-11 IEEE 802.11 dissector infinite loop. Bug 15553. CVE-2019-10897.
    wnpa-sec-2019-12 GSUP dissector infinite loop. Bug 15585. CVE-2019-10898.
    wnpa-sec-2019-13 Rbm dissector infinite loop. Bug 15612. CVE-2019-10900.
    wnpa-sec-2019-14 GSS-API dissector crash. Bug 15613. CVE-2019-10894.
    wnpa-sec-2019-15 DOF dissector crash. Bug 15617. CVE-2019-10896.
    wnpa-sec-2019-16 TSDNS dissector crash. Bug 15619. CVE-2019-10902.
    wnpa-sec-2019-17 LDSS dissector crash. Bug 15620. CVE-2019-10901.
    wnpa-sec-2019-18 DCERPC SPOOLSS dissector crash. Bug 15568. CVE-2019-10903.

* Thu Mar 28 2019 Jan Rękorajski <baggins@pld-linux.org> 396a8e5
- fix cmake generated paths
- rel 2

* Thu Mar 28 2019 Jan Rękorajski <baggins@pld-linux.org> 9e2a9ae
- rel 1

* Tue Mar 05 2019 Adam Gołębiowski <adamg@pld-linux.org> 272fcf7
- todo about unpackaged files

* Tue Mar 05 2019 Adam Gołębiowski <adamg@pld-linux.org> cfa1834
- with gui cleanups, portaudio-devel no longer BR-ed

* Tue Mar 05 2019 Adam Gołębiowski <adamg@pld-linux.org> f78ea8f
- -desktop patch no longer needed

* Tue Mar 05 2019 Adam Gołębiowski <adamg@pld-linux.org> eab87a3
- BR: bcg729-devel, c-ares-devel >= 1.5.0

* Tue Mar 05 2019 Adam Gołębiowski <adamg@pld-linux.org> 8c7ac9b
- not really needed, we only have one gui now

* Tue Mar 05 2019 Adam Gołębiowski <adamg@pld-linux.org> fbffe58
- build and package randpktdump, androiddump, *idl2wrs, dpauxmon, sdjournal

* Tue Mar 05 2019 Adam Gołębiowski <adamg@pld-linux.org> ec8bfdc
- updated to 3.0.0
- gtk gui dropped - no need for separate gui-common subpackage
- merge -gui-common and -qt into main package
- switch to cmake build
- update BR deps as per NEWS file
- release 0.1, builds, needs polishing

* Thu Feb 28 2019 Adam Gołębiowski <adamg@pld-linux.org> dd8602c
- updated to 2.6.7 (solves CVE-2019-9209, CVE-2019-9208, wnpa-sec-2019-08)
  2.6.6 solves: CVE-2019-5716, CVE-2019-5717, CVE-2019-5718, CVE-2019-5719

* Thu Nov 29 2018 Adam Gołębiowski <adamg@pld-linux.org> 6312542
- updated to 2.6.5, solves CVE-2018-19622, CVE-2018-19623, CVE-2018-19624,
  CVE-2018-19625, CVE-2018-19626, CVE-2018-19627, CVE-2018-19628

* Wed Oct 24 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> fdb8d76
- BR: libmaxminddb-devel

* Wed Oct 24 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> 4ad0e35
- fix 'gui' bcond

* Wed Oct 17 2018 Adam Gołębiowski <adamg@pld-linux.org> 2b45c3c
- updated to 2.6.4, solves:
   in 2.6.3: CVE-2018-16056, CVE-2018-16057, CVE-2018-16058
   in 2.6.4: CVE-2018-18225, CVE-2018-18226, CVE-2018-18227

* Thu Aug 16 2018 Jan Rękorajski <baggins@pld-linux.org> 3ab5984
- up to 2.6.2

